%define	_DBprefix	/usr
%define	__s		-s
%define	_libdb_a	libdb-3.0.a

Summary: BSD database library for C
Name: db3
Version: 3.0.55
Release: 0.6
Source: http://www.sleepycat.com/update/%{version}/db-%{version}.tar.gz
Patch0: http://www.sleepycat.com/update/%{version}/patch.3.0.55.1
Patch1: db-3.0.55-linux.patch
Patch2: db-3.0.55-jbj.patch
URL: http://www.sleepycat.com
Copyright: GPL
Group: Libraries
PreReq: /sbin/ldconfig
BuildRoot: %{_tmppath}/%{name}-root
Prefix: %{_prefix}

%package devel
Summary: development libraries and header files for Berkelet database library
Group: Libraries
Prefix: %{_prefix}

%description
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB is used by many applications, including Python and Perl, so this
should be installed on all systems.

%description devel
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains the header files, libraries, and documentation for
building programs which use Berkeley DB.

%prep
%setup -q -n db-%{version}
%patch0 -p0
%patch1 -p1 -b .linux

# XXX not applied
#%patch1 -p1 -b .jbj

%build

cd build_unix

# XXX --enable-posixmutexes (missing pthread_{cond,mutex}attr_setpshared)
# XXX --enable-tcl (needs -lpthreads)
# XXX --enable-cxx (barfs on clone proto in /usr/include/bits/sched.h)
# XXX --enable-debug_{r,w}op should be disabled for production.
CFLAGS="$RPM_OPT_FLAGS" ../dist/configure --prefix=%{_prefix} --enable-debug --enable-compat185 --enable-diagnostic --enable-dump185 --enable-shared --enable-static # --enable-posixmutexes --enable-tcl # --enable-test --enable-debug_rop --enable-debug_wop

make libdb=%{_libdb_a} %{_libdb_a}

# Static link with old db-185 libraries.
make libdb=%{_libdb_a} db_dump185.lo

# XXX the -static flags is lost, leaving libdb.so.2 dependency
#ln -s db_dump185.lo db_dump185.o
#make libdb=%{_libdb_a}  LDFLAGS="%{__s} -static" LIBS="-L%{_prefix}/lib -ldb1" db_dump185

cc %{__s} -static -o db_dump185 db_dump185.lo -L%{_prefix}/lib -ldb1

# Compile rest normally.
make libdb=%{_libdb_a}  LDFLAGS="%{__s}"

%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/include
mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/lib

cd build_unix

# XXX install_static_cxx
# XXX install_dynamic_cxx
# XXX install_tcl
# XXX install_java
# XXX install_docs (handled by %docs)
make libdb=%{_libdb_a} LDFLAGS="%{__s}" prefix=${RPM_BUILD_ROOT}%{_prefix} install_include install_dynamic install_static install_utilities

# XXX annoying
set -x
( cd ${RPM_BUILD_ROOT}

# XXX Avoid colliding with glibc-2.1.x for now.
  mkdir -p .%{_prefix}/include/db3
  mv .%{_prefix}/include/*.h .%{_prefix}/include/db3
  for F in .%{_prefix}/bin/db_* ; do
    mv $F `echo $F | sed -e 's,/db_,/db3_,'`
  done
)
set +x

%clean
rm -rf ${RPM_BUILD_ROOT}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc LICENSE README docs examples_c
#%doc examples_cxx
#%{_DBprefix}/lib/libdb.so
#%{_DBprefix}/lib/libdb-3.so
%{_DBprefix}/lib/libdb-3.0.so
%{_DBprefix}/bin/db*_archive
%{_DBprefix}/bin/db*_checkpoint
%{_DBprefix}/bin/db*_deadlock
%{_DBprefix}/bin/db*_dump
%{_DBprefix}/bin/db*_dump185
%{_DBprefix}/bin/db*_load
%{_DBprefix}/bin/db*_printlog
%{_DBprefix}/bin/db*_recover
%{_DBprefix}/bin/db*_stat

%files devel
%defattr(-,root,root)
#%{_DBprefix}/bin/dbtest
%{_DBprefix}/lib/libdb-3.0.la
%{_DBprefix}/lib/%{_libdb_a}
%{_DBprefix}/include/db3/db.h
%{_DBprefix}/include/db3/db_185.h
%{_DBprefix}/include/db3/db_cxx.h

%changelog
* Tue May  2 2000 Jeff Johnson <jbj@redhat.com>
- disable --enable-test --enable-debug_rop --enable-debug_wop.
- disable --enable-posixmutexes --enable-tcl as well, to avoid glibc-2.1.3
  problems.

* Mon Apr 24 2000 Jeff Johnson <jbj@redhat.com>
- add 3.0.55.1 alignment patch.
- add --enable-posixmutexes (linux threads has not pthread_*attr_setpshared).
- add --enable-tcl (needed -lpthreads).

* Sat Apr  1 2000 Jeff Johnson <jbj@redhat.com>
- add --enable-debug_{r,w}op for now.
- add variable to set shm perms.

* Sat Mar 25 2000 Jeff Johnson <jbj@redhat.com>
- update to 3.0.55

* Tue Dec 29 1998 Jeff Johnson <jbj@redhat.com>
- Add --enable-cxx to configure.

* Thu Jun 18 1998 Jeff Johnson <jbj@redhat.com>
- Create.
